function [BIC selected_beta]=BICminimizer(xlist_ext,X,y,groups,tau,includepic)
% Find the column in xlist_ext that minimizes the BIC.

numpts_ext=size(xlist_ext,2);
%numobs is the nuber of observations which is n, but in case we have a
%vector of response variables, it would n \times the number of response
%variables.
numobs=size(y,1);

% calculate R for points in xlist_ext
Rlist_ext=zeros(1,numpts_ext);
for i=1:numpts_ext
    Rlist_ext(i)=mixednorm(xlist_ext(:,i),groups);
end

% find the BIC for each column ox xlist_ext
tolerance=0.00001;
BIC2=zeros(1,numpts_ext);
for i=1:numpts_ext
    r=y-X*xlist_ext(:,i);
    elbow_size=sum(abs(r)<tolerance);
    loss=sumrho(r,tau);
    BIC2(i)=log(loss/numobs)+((log(numobs)/(2*numobs))*elbow_size);
end
% find the minimum and it's corresponding \hat{\beta}
[BIC idx]=min(BIC2);
selected_beta=xlist_ext(:,idx);

if includepic
    figure
    plot(Rlist_ext,BIC2)
    title('BIC as a function of R')
    xlim([0 max(Rlist_ext)])
end