function f=array2tex(x,varargin)
% convert an array of (complex) numbers to TeX format 
% varargin are
% type: '\frac' (default) or '/'
% openbracket: '(' (default) or any other TeX bracket compatible with \left
% closebracket: ')' (default) or any other TeX bracket compatible with \right
% tolerance: 10^(-10) (default) or any positive number

% Last modified by Ignace Loris (igloris@ulb.ac.be) on 14/12/2012

% set defaults
openbracket='(';
closebracket=')';
type='frac';
tolerance=10^(-10);
nargin=1+size(varargin,2);
if nargin>1 
    type=varargin{1};
    if nargin>2
        openbracket=varargin{2};
        if nargin>3
            closebracket=varargin{3};
            if nargin>4
                tolerance=varargin{4};
            end
        end
    end
end

linebreak=sprintf('\n');
f=['\left' openbracket];
f=[f '\begin{array}{'];
for i=1:size(x,2) f=[f 'c'];end;
f=[f, '}' linebreak];
for i=1:size(x,1)
    for j=1:size(x,2)-1
        str=cplx2tex(x(i,j),type,tolerance);
        f=[f str ' & '];
    end
    str=cplx2tex(x(i,size(x,2)),type,tolerance);
    f=[f str '\\' linebreak];
end;
%remove final '\\'
f=f(1:numel(f)-3);
f=[f linebreak];
f=[f '\end{array}\right' closebracket ];

