function f=cplx2tex(x,varargin)
% convert a single (complex) number to TeX format using either '/' or
% '\frac{}{}' for fractions

% Last modified by Ignace Loris (igloris@ulb.ac.be) on 14/12/2012

nargin=1+size(varargin,2);
if nargin>1 
    type=varargin{1};
    if nargin>2
        tolerance=varargin{2};
    else
        tolerance=10^(-10);
    end
else
    type='frac';
    tolerance=10^(-10);
end

tmp1=real(x);
tmp2=imag(x);

realstring=real2tex(tmp1,type,tolerance);
if tmp2>0
    imstring=real2tex(tmp2,type,tolerance);
else
    imstring=real2tex(-tmp2,type,tolerance);
end

if strcmp(realstring,'0') && strcmp(imstring,'0')
    f='0';
    return
end;
if strcmp(imstring,'0')
    f=realstring;
    return;
end;

if strcmp(realstring,'0');
    f=[real2tex(tmp2,type,tolerance) 'i'];
    return;
end

if tmp2>0
    f=[realstring '+' imstring 'i'];
else
    f=[realstring '-' imstring 'i'];
end
