function xlist_ext=interpolatelist(xlist,groups,num)
% Interpolate between the break points in xlist.
% num= the number of points interpolated between two successive columns of
% xlist

numparam=size(xlist,1);
numpts=size(xlist,2);

% calculate R for break points in xlist
Rlist=zeros(1,numpts);
for i=1:numpts
    Rlist(i)=mixednorm(xlist(:,i),groups);
end

% create extended list (linear interpolation)
xlist_ext=zeros(numparam,1+(numpts-1)*(num+1));
xlist_ext(:,1)=xlist(:,1);
for i=1:numpts-1
    R1=Rlist(i);
    R2=Rlist(i+1);
    beta1=xlist(:,i);
    beta2=xlist(:,i+1);
    Rlist_int=linspace(R1,R2,num+2);
    Rlist_int(1)=[];% do NOT include beta1, do include beta2
    
    beta_new=zeros(numparam,num+1);
    % interpolate
    for j=1:num+1
        tmp1=(beta2-beta1)/(R2-R1);
        tmp2=Rlist_int(j)-R1;
        beta_new(:,j)=(tmp1*tmp2)+beta1;
    end
    
    xlist_ext(:,2+(i-1)*(num+1):1+i*(num+1))=beta_new;
end
