function [f,varargout]=mixednormdual(x,groups)
% calculate the dual mixed norm of x:
% f=max_{g\in groups} sum_{i\in group g}(|x_i|)
% optionally return in which group(s) the max was attained

% Last modified by Ignace Loris (igloris@ulb.ac.be) on 12/10/2012

nout = numel(nargout);
tmp=[];
for g=1:numel(groups)
    tmp=[tmp,norm(x(groups{g}),1)];
end
f=max(tmp);

if nout>0 
    ind=find(tmp==f);
    varargout{1}=ind;
end