function g=projl1(w,l1target)
%projection on l1 ball of radius l1target
% works for column vector

% determine threshold such that
% soft thresholding of wlist (all positive numbers)
% yields a ||S_tau(w)||_1 equal to l1target
% wlist is sorted low to high
% this implies ||S_tau(wlist)||_1 is pieceiwse linear
% stricly descreasing function of tau

% search by halving
% then linear interpolation

% Last modified by Ignace Loris (igloris@ulb.ac.be) on 14/08/2012

wlist=sort(abs([0; w]),'ascend');

restnodes=wlist;
numberleft=length(restnodes);


%check that l1norm>l1target else...

if l1target<sum(abs(w))
    % find threshold
    %middle tau
    taumid=wlist(round(length(wlist)/2));
    
    while numberleft>2;
        midpoint=round(numberleft/2);
        taumid=restnodes(midpoint);
        l1valuemid=sum(abs(soft(w,taumid)));
        if l1valuemid==l1target; % lucky case
            %threshold=taumid;
            restnodes=[taumid]; %to quit the while loop
        elseif l1valuemid>l1target;
            restnodes(1:midpoint-1)=[];
        else l1valuemid<l1target || isnan(l1valuemid);
            restnodes(midpoint+1:end)=[];
        end;
        numberleft=length(restnodes);
    end
    
    if length(restnodes)==1;
        f=taumid; % lucky case
    else %need linear interpolation
        taua=restnodes(1);
        taub=restnodes(2);
        % should have taua<taub and
        l1a=sum(abs(soft(w,taua)));
        l1b=sum(abs(soft(w,taub)));
        if isnan(l1b); l1b=0; end;
        if l1a==l1b;
            f=taua;
        else
            f=(l1target-l1a)*(taua-taub)/(l1a-l1b)+taua;
        end;
    end;
else
    f=0; % no thresholding needed in this case
end;


if f>0
    g=soft(w,f);
else
    g=w;
end;