function g=projmixednormball(w,groups,radius)
%projection on mixed norm ball ||x||_mix<=radius
% works for column vector

% determine threshold such that
% thresholding of wlist (all positive numbers)
% yields a ||S_tau(w)||_mix equal to radius
% wlist is sorted low to high
% this implies ||S_tau(wlist)||_mix is piecewise linear
% descreasing function of tau

% search by halving, then linear interpolation

% Last modified by Ignace Loris (igloris@ulb.ac.be) on 15/07/2013


breakpointsbis=zeros(numel(w)+1,1);
for i=1:numel(groups)
    nn=numel(groups{i});
    tmp=sort(abs(w(groups{i})),'descend');% descending order
    tmp2=cumsum(tmp)-(1:nn)'.*tmp;
    tmp2(1)=tmp2(end)+nn*tmp(end);% replace zero with 1-norm of group
    breakpointsbis(groups{i}+1)=tmp2;
end
wlist=sort(breakpointsbis);

restnodes=wlist;
numberleft=length(restnodes);

%check that mixed norm>radius else...

if radius<mixednorm(w,groups)
    % find threshold
    %middle tau
    taumid=wlist(round(length(wlist)/2));
    
    while numberleft>2;
        midpoint=round(numberleft/2);
        taumid=restnodes(midpoint);
        mixednormmid=mixednorm(softgroup(w,taumid,groups),groups);
        if mixednormmid==radius; % lucky case
            %threshold=taumid;
            restnodes=[taumid]; %to quit the while loop
        elseif mixednormmid>radius;
            restnodes(1:midpoint-1)=[];
        else mixednormmid<radius || isnan(mixednormmid);
            restnodes(midpoint+1:end)=[];
        end;
        numberleft=length(restnodes);
    end
    
    if length(restnodes)==1;
        f=taumid; % lucky case
    else %need linear interpolation
        taua=restnodes(1);
        taub=restnodes(2);
        % should have taua<taub and
        l1a=mixednorm(softgroup(w,taua,groups),groups);
        l1b=mixednorm(softgroup(w,taub,groups),groups);
        if isnan(l1b); l1b=0; end;
        if l1a==l1b;
            f=taua;
        else
            f=(radius-l1a)*(taua-taub)/(l1a-l1b)+taua;
        end;
    end;
else
    f=0; % no thresholding needed in this case
end;


if f>0
    g=softgroup(w,f,groups);
else
    g=w;
end;