function f=real2tex(x,varargin)
% convert a single (real) number to TeX format using either '/' or
% '\frac{}{}' for fractions

% Last modified by Ignace Loris (igloris@ulb.ac.be) on 14/12/2012

nargin=1+size(varargin,2);
if nargin>1 
    type=varargin{1};
    if nargin>2
        tolerance=varargin{2};
    else
        tolerance=10^(-10);
    end
else
    type='frac';
    tolerance=10^(-10);
end

if abs(x)<tolerance
    f='0';
else
    [n,d]=rat(x);
    if abs(d-1)>=10^(-10)
        switch type
            case 'frac'
                f=['\frac{' num2str(n) '}{' num2str(d) '}'];
            case '/'
                f=[num2str(n) '/' num2str(d)];
            otherwise
                f=['\frac{' num2str(n) '}{' num2str(d) '}'];
        end
    else
        f=num2str(n);
    end
end
