function f=verifyminimizergroup(A,b,groups,x,lambda,u,w,varargin)
% verify that x,u,w satisfy the equations
% A'*w+lambda*u=0,
% w in subgradient of 1 norm at A*x-b
% u in subgradient of mixed norm at x
% verifyminimizergroup(A,b,x,lambda,u,w,left,right):
%  same as before but with asymetric "1-norm" of A*x-b
% left and right are lists of postive numbers equal to slopes on left and right and
% side of ||A*x-b||_1-> \sum_i [left(i)(A*x-b)_i if (A*x-b)_i<=0
%                               -right(i)(A*x-b)_i if (A*x-b)_i>=0]

% Last modified by Ignace Loris (igloris@ulb.ac.be) on 10/10/2012

optargin = size(varargin,2);

if optargin==0
    left=ones(numel(b),1);
    right=ones(numel(b),1);
else
    left=varargin{1};
    right=varargin{2};
end

f=[norm(A'*w+lambda*u),... 
   norm(w-projasyminf(w+A*x-b,-left,right)),...
   norm(u-projl1group(u+x,1,groups))];